#define std_lang_ByteArray_IMPORT
#define std_lang_Chunk_IMPORT
#define std_lang_Object_IMPORT

#include <stdlib.h>
#include <string.h>
#include <std/lang/ByteArray.h>
#include <std/lang/Chunk.h>
#include <std/lang/Object.h>

struct ByteArray {
    size_t size;
    unsigned char data[0];
};

struct ByteArray *
ByteArray_create(size_t size)
{
    struct ByteArray *impl;

    if ((impl = malloc(sizeof(*impl) + size)) == NULL) {
        return NULL;
    }
    impl->size = size;
    return impl;
}

struct ByteArray *
ByteArray_createWithData(const void *data, size_t size)
{
    struct ByteArray *impl;

    if ((impl = ByteArray_create(size)) == NULL)
	return NULL;
    memcpy(impl->data, data, size);
    return impl;
}

void
ByteArray_free(struct ByteArray *impl)
{
    free(impl);
}

struct Chunk
ByteArray_getChunk(struct ByteArray *impl)
{
    struct Chunk c;

    c.data = impl->data;
    c.size = impl->size;
    return c;
}

void *
ByteArray_getData(struct ByteArray *impl)
{
    return impl->data;
}

size_t
ByteArray_getSize(struct ByteArray *impl)
{
    return impl->size;
}
